open Printf
open MIPSOps
open Primitive
open PP
open Integer

type value =
  | VInt of int32

let asInt = function
  | VInt i -> i

type environment = value ref StringMap.t
type definitions = PP.procedure StringMap.t
type 'a interpreter = definitions -> environment -> environment -> 'a

let interpret_primitive p actuals =
  match p, actuals with
  | Writeln, [ v ] -> fprintf stdout "%ld\n%!" (asInt v); None
  | _ -> failwith "Pas implment"

let interpret_expression defs genv env = function
  | EConst (ConstInt i) -> VInt i
  | _ -> failwith "Pas implment"

let interpret_call defs genv env callee actuals =
  let actuals = List.map (interpret_expression defs genv env) actuals in
  match callee with
  | CPrimitiveFunction p -> interpret_primitive p actuals
  | _ -> failwith "Pas implment"

let interpret_condition defs genv env = function
  | _ -> failwith "Pas implment"

let rec interpret_instruction defs genv env = function
  | IProcCall (callee, es) -> ignore (interpret_call defs genv env callee es)
  | ISeq (is) -> List.iter (interpret_instruction defs genv env) is
  | _ -> failwith "Pas implment"

let interpret p = interpret_instruction StringMap.empty StringMap.empty StringMap.empty p.main

