(* This module provides an interpreter for [PP] programs. *)

val interpret: PP.program -> unit

(* Alias for types, to increase readability *)

type environment
type definitions

(* Types and functions to implement in order to complete the interpreter. *)

type value

val interpret_primitive : Primitive.primitive -> value list -> value option

val interpret_expression : definitions -> environment -> environment -> PP.expression -> value

val interpret_call : definitions -> environment -> environment -> Primitive.callee -> PP.expression list -> value option

val interpret_condition : definitions -> environment -> environment -> PP.condition -> bool

val interpret_instruction : definitions -> environment -> environment -> PP.instruction -> unit
