let doif b f x =
  if b then f x

let applyif b f x =
  doif b f x;
  x

let program : LPP.program =
  let channel = open_in Settings.filename in
  let lexbuf = Lexing.from_channel channel in
  lexbuf.Lexing.lex_curr_p <-
      { 
	Lexing.pos_fname = Settings.filename; 
	Lexing.pos_lnum  = 1;
	Lexing.pos_bol   = 0; 
	Lexing.pos_cnum  = 0
      };
  try
    let program = Parser.program Lexer.main lexbuf in
    close_in channel;
    program
  with Parser.Error ->
    Error.error2
      (Lexing.lexeme_start_p lexbuf)
      (Lexing.lexeme_end_p lexbuf)
      "Syntax error."

let () =
  Typechecking.typecheck_program program

let program : PP.program =
  Lpp2pp.translate_program program

let () =
  doif Settings.ipp InterpretPP.interpret (
    Print.showif Settings.dpp PrintPP.print_program program
  )


